<?php
/**
 * @package     Joomla.Platform
 * @subpackage  Form
 *
 * @copyright   Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('JPATH_PLATFORM') or die;

class JFormFieldK2orderfield extends JFormFieldList
{
	/**
	 * The form field type.
	 *
	 * @var    string
	 *
	 * @since  11.1
	 */
	protected $type = 'K2orderfield';

	protected function getOptions()
	{
		require_once(JPATH_ROOT.'/modules/mod_jak2filter/helper.php');

		$options = array();
	$options[] = JHtml::_('select.option', 'zelevance', JText::_('RELEVANCE'));
	$options[] = JHtml::_('select.option', 'date', JText::_('JAK2_OLDEST_FIRST'));
 	$options[] = JHtml::_('select.option', 'rdate', JText::_('JAK2_MOST_RECENT_FIRST'));
	$options[] = JHtml::_('select.option', 'publishUp', JText::_('JAK2_RECENTLY_PUBLISHED'));
	$options[] = JHtml::_('select.option', 'alpha', JText::_('JAK2_TITLE_ALPHABETICAL'));
 	$options[] = JHtml::_('select.option', 'ralpha', JText::_('JAK2_TITLE_REVERSEALPHABETICAL'));
	$options[] = JHtml::_('select.option', 'order', JText::_('JAK2_ORDERING'));
 	$options[] = JHtml::_('select.option', 'rorder', JText::_('JAK2_ORDERING_REVERSE'));
	$options[] = JHtml::_('select.option', 'featured', JText::_('JAK2_FEATURED_FIRST'));
	$options[] = JHtml::_('select.option', 'hits', JText::_('JAK2_MOST_POPULAR'));
	$options[] = JHtml::_('select.option', 'best', JText::_('JAK2_HIGHEST_RATED'));
	$options[] = JHtml::_('select.option', 'modified', JText::_('JAK2_LATEST_MODIFIED'));
	$options[] = JHtml::_('select.option', 'zand', JText::_('JAK2_RANDOM_ORDERING'));
	//Extra Fields
	$db = JFactory::getDbo();
	$aXFSupported = array('select', 'multipleSelect', 'radio', 'labels', 'textfield', 'date');
	$query = "SELECT f.`id`, f.name, f.group, g.name AS group_name
			FROM #__k2_extra_fields f
			INNER JOIN #__k2_extra_fields_groups g ON f.group = g.id
			WHERE f.`type` IN ('".implode("','", $aXFSupported). "')
			ORDER BY g.name, f.name";
	$db->setQuery($query);
	$items = $db->loadObjectList();
	if(count($items)) {
		$params = JComponentHelper::getParams('com_jak2filter');
		$xfDataType = $params->get('extra_fields_data_type');

		$dt = array();
		if(is_array($xfDataType) && count($xfDataType)) {
			foreach($xfDataType as $val) {
				@list($xfid, $type) = explode(':', $val);
				$dt[$xfid] = $type;
			}
		}

		$group = '';
		foreach($items as $item) {
			if(is_array($activeGroups) && !in_array($item->group, $activeGroups)) {
				//get Dynamic order by options
				continue;
			}
			$type = isset($dt[$item->id]) ? $dt[$item->id] : 'string';
			if($group != $item->group_name) {
				if($group != '') {
					$options[] = JHtml::_('select.option', '</OPTGROUP>', $group);
				}
				$group = $item->group_name;
				$options[] = JHtml::_('select.option', '<OPTGROUP>', $group);
			}
			if($type == 'number') {
				$options[] = JHtml::_('select.option', 'xf'.$item->id, JText::sprintf('XFIELD_ORDER_ASCENDING', $item->name));
 				$options[] = JHtml::_('select.option', 'rxf'.$item->id, JText::sprintf('XFIELD_ORDER_DESCENDING', $item->name));
			} else {
				$options[] = JHtml::_('select.option', 'xf'.$item->id, JText::sprintf('XFIELD_ORDER_ALPHABETICAL', $item->name));
				$options[] = JHtml::_('select.option', 'rxf'.$item->id, JText::sprintf('XFIELD_ORDER_REVERSE_ALPHABETICAL', $item->name));
			}
		}
		$options[] = JHtml::_('select.option', '</OPTGROUP>', $group);
	}
		$options = array_merge(parent::getOptions(), $options);
		return $options;
	}
}
